// many independent blocks with answer 0
#include "testlib.h"
#include <algorithm>
using namespace std;
#define mp make_pair
#define pb push_back
#define fs first
#define sc second

pair< vector<int>, vector<int> > gen_small(int block_size, int block_c, int allow_zeroes) {
	vector<int> s, t;
	for (int i = 0; i < block_size; ++i) {
		s.pb(rnd.next(1, block_c)), t.pb(rnd.next(1, block_c));
	}
	bool bad;
	do {
		bad = false;
		vector< pair<int, int> > e;
		for (int i = 0; i < (int) s.size(); ++i) {
			e.pb(mp(s[i], 1)), e.pb(mp(t[i], -1));
		}
		e.pb(mp(1, -1)), e.pb(mp(block_c, 1));
		sort(e.begin(), e.end());
		int sum = 0;
		for (int i = 0; i + 1 < (int) e.size(); ++i) {
			sum += e[i].sc;
			bool need_edge = (sum > 0) || (!allow_zeroes && (sum == 0));
			if (need_edge && (e[i + 1].fs != e[i].fs)) {
				s.pb(rnd.next(e[i + 1].fs, block_c)), t.pb(rnd.next(1, e[i].fs));
				bad = true;
			}
		}
	} while (bad);
	return mp(s, t);
}

int main(int argc, char ** argv) {
	registerGen(argc, argv, 1);
	if (argc <= 1) {
		printf("Usage: gen_special_3 <n> [<need_answer>=1] [<block_size>=10] [<block_c>=100] [<allow_zeroes>=0]\n");
		return 1;
	}
	int n = atoi(argv[1]);
	int need_answer = (argc > 2) ? atoi(argv[2]) : 1;
	int block_size = (argc > 3) ? atoi(argv[3]) : 10;
	int block_c = (argc > 4) ? atoi(argv[4]) : 100;
	int allow_zeroes = (argc > 5) ? atoi(argv[5]) : 0;
	vector<int> s, t;
	for (int start = 1; ; start += block_c + 1) {
		pair< vector<int>, vector<int> > part = gen_small(block_size, block_c, allow_zeroes);
		int part_size = (int) part.fs.size();
		if ((int) s.size() + part_size > n) break;
		for (int i = 0; i < part_size; ++i) {
        	s.pb(part.fs[i] + start), t.pb(part.sc[i] + start);
        }
	}
	n = (int) s.size();
	printf("%d %d\n", n, need_answer);
	for (int i = 0; i < n; ++i) {
		printf("%d %d\n", s[i], t[i]);
	}
	return 0;
}
