// many independent blocks with unique answer
#include "testlib.h"
#include <algorithm>
using namespace std;
#define mp make_pair
#define pb push_back
#define fs first
#define sc second
const int INF = 1e9;

pair< vector<int>, vector<int> > gen_small(int block_size, int block_c) {
	while (true) {
		vector<int> s, t, p;
		for (int i = 0; i < block_size; ++i) {
			s.pb(rnd.next(1, block_c)), t.pb(rnd.next(1, block_c)), p.pb(i);
		}
		int min_cost = INF, min_cnt = 0;
		do {
			int cost = 0;
			for (int i = 1; i < block_size; ++i) {
				cost += max(0, t[p[i - 1]] - s[p[i]]);
			}
			if (cost < min_cost) {
				min_cost = cost, min_cnt = 0;
			}
			if (cost == min_cost) {
				min_cnt++;
			}
		} while (next_permutation(p.begin(), p.end()));
		if (min_cnt == 1) {
			return mp(s, t);
		}
	}
	return mp(vector<int>(), vector<int>());
}

int main(int argc, char ** argv) {
	registerGen(argc, argv, 1);
	if (argc <= 1) {
		printf("Usage: gen_special_4 <n> [<need_answer>=1] [<block_size>=5] [<block_c>=100]\n");
		return 1;
	}
	int n = atoi(argv[1]);
	int need_answer = (argc > 2) ? atoi(argv[2]) : 1;
	int block_size = (argc > 3) ? atoi(argv[3]) : 5;
	int block_c = (argc > 4) ? atoi(argv[4]) : 100;
	vector<int> s, t;
	for (int start = 1; ; start += block_c + 1) {
		pair< vector<int>, vector<int> > part = gen_small(block_size, block_c);
		int part_size = (int) part.fs.size();
		if ((int) s.size() + part_size > n) break;
		for (int i = 0; i < part_size; ++i) {
        	s.pb(part.fs[i] + start), t.pb(part.sc[i] + start);
        }
	}
	n = (int) s.size();
	printf("%d %d\n", n, need_answer);
	for (int i = 0; i < n; ++i) {
		printf("%d %d\n", s[i], t[i]);
	}
	return 0;
}
