#! /usr/bin/python

import sys
import random

def rand(*arg):
    if len(arg) == 2: return random.randint(arg[0],arg[1])
    return random.randint(0,arg[0]-1)
    
MAX_ST = 10**9

class Generator:
    
    def generate(self, typ, n, need):
        f = {
            "SEMI": self.semirand,
            "GRAPH": self.complicated_graph,
            "CONN": self.connected_graph,
        }
        N,S,T = f[typ](n)

        print N, need
        for s,t in zip(S,T):
            print s,t

    # increase zeros in cumulative sum and connected components
    def semirand(self, n):
        d = [1] * n
        zero = rand(n/4, n)
        for i in xrange(zero):
            d[i] = 0
        random.shuffle(d)
        d.append(0)
        g = rand(zero/2, zero)
        gid = []
        x = []
        cnt = 0
        for i in xrange(n + 1):
            cnt += 1
            if d[i] == 0:
                p = ([1] * cnt) + ([-1] * cnt)
                while True:
                    random.shuffle(p)
                    if len(x) == 0 and p[0] == -1:
                        continue
                    if i == n and p[-1] == 1:
                        continue
                    break
                x += p
                gi = rand(g)
                if i == n and len(gid) > 0:
                    gi = gid[0]
                gid += [gi] * (cnt*2)
                cnt = 0

        s,t = [],[]
        sp,tp = [],[]
        for i in xrange(1, n*2 + 1):
            if x[i] == 1:
                sp.append(i-1)
            else:
                tp.append(i-1)
        random.shuffle(sp)
        gcand = [[] for i in xrange(g)]
        for i in xrange(n):
            gcand[gid[tp[i] + 1]].append(tp[i])
        pos = [rand(1, MAX_ST) for i in xrange(n*2)]
        pos.sort()
        for i in xrange(n):
            s.append(pos[sp[i]])
            gi = gid[sp[i] + 1]
            r = rand(len(gcand[gi]))
            t.append(pos[gcand[gi][r]])
            gcand[gi][r] = gcand[gi][-1]
            gcand[gi].pop()
        return n,s,t

    # complicated graph
    def complicated_graph(self, n):
        pst = set()
        pst.add(0)
        pst.add(MAX_ST)
        for i in xrange(n-1):
            while True:
                x = rand(2, MAX_ST-2)
                if x-1 in pst: continue
                if x in pst: continue
                if x+1 in pst: continue
                pst.add(x)
                break
        pos = list(pst)
        pos.sort()
        g = rand(n/2, n)
        gid = [0]
        for i in xrange(n-1):
            gid.append(rand(g))
        gid.append(0)
        gr = [[] for i in xrange(g)]
        for i in xrange(1,n):
            gr[gid[i]].append(i)
        for i in xrange(g):
            random.shuffle(gr[i])
        gr[0].insert(0, 0)
        gr[0].insert(len(gr[0]), n)

        s,t = [],[]
        for i in xrange(g):
            gn = len(gr[i])
            for j in xrange(gn):
                if i == 0 and j == gn-1: break
                s.append(pos[gr[i][j]] + 1)
                t.append(pos[gr[i][(j+1) % gn]])
        st = zip(s,t)
        random.shuffle(st)
        s,t = zip(*st)
        return n,s,t
    # connected graph
    def connected_graph(self, n):
        pst = set()
        pst.add(0)
        pst.add(MAX_ST)
        for i in xrange(n-1):
            while True:
                x = rand(2, MAX_ST-2)
                if x-1 in pst: continue
                if x in pst: continue
                if x+1 in pst: continue
                pst.add(x)
                break
        pos = list(pst)
        pos.sort()

        p = []
        for i in xrange(n-1):
            p.append(i + 1)
        random.shuffle(p)
        p.insert(0, 0)
        p.insert(n, n)

        s,t = [],[]
        for j in xrange(n):
            s.append(pos[p[j]] + 1)
            t.append(pos[p[j+1]])
        st = zip(s,t)
        random.shuffle(st)
        s,t = zip(*st)
        return n,s,t

if __name__ == '__main__':
    args = len(sys.argv)
    if args == 4:
        _,n,typ,need = [f(x) for x,f in zip(sys.argv,[str,int,str,int])]
    else:
        sys.stderr.write('invalid arguments\n')
        exit(0)
    random.seed(1729)

    g = Generator()
    g.generate(typ, n, need)
