// name = railroad_av_wa_greedy.java, type = java7

import java.io.*;
import java.util.*;

public class railroad {

    class Node {
        List<Integer> ids = new ArrayList<>();
        int s, t;

        public Node(int id, int s, int t) {
            ids.add(id);
            this.s = s;
            this.t = t;
        }
    }

    public long plan_roller_coaster(int[] s, int[] t) {
        int n = s.length;
        Node[] nodes = new Node[n];
        boolean[] used = new boolean[n];
        for (int i = 0; i < n; i++) {
            nodes[i] = new Node(i, s[i], t[i]);
        }

        long result = 0;
        for (int IT = 0; IT < n - 1; IT++) {
            int best = Integer.MAX_VALUE;
            int bestI = -1, bestJ = -1;

            for (int i = 0; i < n; i++) {
                for (int j = 0; j < n; j++) {
                    if (i == j || used[i] || used[j]) {
                        continue;
                    }
                    int cost = Math.max(0, nodes[i].t - nodes[j].s);
                    if (cost < best) {
                        best = cost;
                        bestI = i;
                        bestJ = j;
                    }
                }
            }
            result += best;
            nodes[bestI] = mergeNodes(nodes[bestI], nodes[bestJ]);
            used[bestJ] = true;
        }

        return result;
    }

    private Node mergeNodes(Node first, Node second) {
        first.ids.addAll(second.ids);
        first.t = second.t;
        return first;
    }

    
}
